<?php

use Nette\Security as NS;

class DatabaseAuthenticator extends Nette\Object implements NS\IAuthenticator
{
    private $database;

    private $config = array(
        'table' => 'user',
        'username' => 'username',
        'password_hash' => 'password'
    );

    function __construct(Nette\Database\Context $database, $config=null)
    {
        $this->database = $database;
        is_array($config) && $this->config = array_merge($this->config, $config);
    }

    function authenticate(array $credentials)
    {
        list($username, $password) = $credentials;

        $row = $this->database->table($this->config['table'])
            ->where($this->config['username'], $username)
            ->fetch();

        if (!$row)
            throw new NS\AuthenticationException('Invalid username or password.');

        if (!NS\Passwords::verify($password, $row[$this->config['password_hash']]))
            throw new NS\AuthenticationException('Invalid username or password.');

        return new NS\Identity($row->id, $row->role);
    }
}
